unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, strutils, FileUtil, Forms, Controls,
  Graphics, Dialogs, StdCtrls, ComCtrls, blcksock, httpsend;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
  private
    http: THTTPSend;
    TotalBytes, CurrentBytes: Integer;
    procedure SocketGetCallBack(Sender: TObject; Reason: THookSocketReason;
      const Value: String);
    function GetFileName(var Str: String): Boolean;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
  s: String;
begin
  Progressbar1.Position:=0;
  http:=THTTPSend.Create;
  http.Sock.OnStatus:=@SocketGetCallBack;
  if http.HTTPMethod('HEAD', Edit1.Text) then
  begin
    // search for "Content-Length:" in header
    for i:=0 to http.Headers.Count-1 do
    begin
      s:=UpperCase(http.Headers[i]);
      if Pos('CONTENT-LENGTH:', s) > 0 then
        TotalBytes:=StrToIntDef(Copy(s, Pos(':', s) + 1, Length(s)), 0);
    end;

    // get the file
    http.Headers.Clear;
    if http.HTTPMethod('GET', Edit1.Text) then
    begin
      s:=Edit1.Text;
      if not GetFileName(s) then s:='DummyFile.dat';
      http.Document.SaveToFile(s);

      Progressbar1.Position:=0;
      ShowMessage('File['+s+'] von ['+Edit1.Text+'] erfolgreich heruntergeladen!');
    end;
  end;
  http.Free;
end;

procedure TForm1.SocketGetCallBack(Sender: TObject;
  Reason: THookSocketReason; const Value: String);
begin
  if TotalBytes = 0 then
    Exit;

  case Reason of
    HR_ReadCount:
      begin
        Inc(CurrentBytes, StrToIntDef(Value, 0));
        ProgressBar1.Position := Round(1000 * (CurrentBytes / TotalBytes));
      end;
    HR_Connect:
      CurrentBytes := 0;
  end;
end;

function TForm1.GetFileName(var Str: String): Boolean;
var
  i: Integer;
begin
  Result:=False;
  i:=Length(Str);
  while (i > 0) and (Str[i] <> '/') do dec(i);
  if i > 0 then begin
    Str:=Copy(Str, i + 1, Length(Str) - i);
    Result:=True;
  end;
end;

end.

